<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.patch(`/employee/role/${role.id}`, { preserveScroll: true })" autocomplete="off">
      <h3>Edit Role</h3>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Role Name</label>
              <input id="name" class="input w-full" type="text" placeholder="Enter name" v-model="form.name" />
              <div v-if="form.errors.name" class="text-error">
                {{ form.errors.name }}
              </div>
            </div>
          </div>
        </div>
      </div>


      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Description
              </label>
              <textarea id="employee-name" class="textarea w-full" placeholder="Give a brief description of the role"
                v-model="form.description" />
              <div v-if="form.errors.description" class="text-error">
                {{ form.errors.description }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="text-sm font-medium text-gray-700 mb-3 mt-5">Permissions</div>
      <div class="text-base space-y-2">
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.create_role">
          <label>Create Role</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.read_role">
          <label>Read Role</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.update_role">
          <label>Update Role</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.delete_role">
          <label>Delete Role</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.create_user">
          <label>Create User</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.read_user">
          <label>Read User</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.update_user">
          <label>Update User</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.delete_user">
          <label>Delete User</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.create_leave_type">
          <label>Create Leave Type</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.read_leave_type">
          <label>Read Leave Type</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.update_leave_type">
          <label>Update Leave Type</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.delete_leave_type">
          <label>Delete Leave Type</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.create_department">
          <label>Create Department</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.read_department">
          <label>Read Department</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.update_department">
          <label>Update Department</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.delete_department">
          <label>Delete Department</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.create_form_template">
          <label>Create Form Template</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.read_form_template">
          <label>Read Form Template</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.update_form_template">
          <label>Update Form Template</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.delete_form_template">
          <label>Delete Form Template</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.roster_eligibility">
          <label>Roster Eligibility</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.view_overall_roster">
          <label>View Overall Roster</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.manage_overall_roster">
          <label>Manage Overall Roster</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.manage_department_shift">
          <label>Manage Department Shift</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.admin_dashboard_eligibility">
          <label>Admin Dashboard Eligibility</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.performance_eligibility">
          <label>Performance Eligibility</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.observer_eligibility">
          <label>Observer Eligibility</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.view_attendance">
          <label>View Attendance</label>
        </div>
      </div>

      <!-- Leave eligibility -->
      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Leave eligibility (What kind of leave can users with this role apply for?)</label>
        <multiselect v-model="form.eligible_leaves" :multiple="true" :options="leaveTypes" label="name" track-by="id"
          :customLabel="(leaveType) => `${leaveType.type}`">
        </multiselect>
      </div>

      <div class="text-sm font-medium text-gray-700 mb-3 mt-5">Master details (Editing a field/option with a slight
        tinted background tells that you're editing an existing field/option)</div>

      <!-- Role field -->
      <button type="button" v-if="form.role_fields.length === 0"
        class="border border-dashed border-gray-400 w-full block h-40 text-base" @click="addField">
        Click to add a new field.
      </button>
      <div v-else class="space-y-10">
        <div v-for="(role_field, index) in form.role_fields">
          <div class="w-full p-3 border border-gray-400 rounded-md" :class="{ 'bg-orange-100': role_field.id }">
            <div class="mb-2 flex items-center gap-x-4">
              <button class="block" :id="`dropdownDefaultButton${index}`"
                :data-dropdown-toggle="`dropdown-table${index}`" type="button" data-dropdown-placement="bottom-start"
                data-dropdown-offset-distance="5" data-dropdown-offset-skidding="-12">
                <Icon icon="fa-solid fa-ellipsis-vertical" class="text-gray-500"></Icon>
              </button>
              <div class="font-semibold text-base">Field No. <span class="text-lg font-bold">{{ index + 1 }}</span>
              </div>
            </div>

            <div class="md:flex gap-5 mb-3">
              <div class="flex-1">
                <label class="text-sm block">Field Name</label>
                <input autocomplete="off" v-model="form.role_fields[index].name" :id="`fieldName${index}`"
                  class="input w-full" placeholder="Enter field description or label" required>
              </div>
              <div class="flex-1">
                <label class="text-sm block">Field Type</label>
                <select v-model="form.role_fields[index].type" :id="`fieldType${index}`" class="dropdown w-full">
                  <option>Text</option>
                  <option>Number</option>
                  <option>Checkbox</option>
                  <option>Radio Button</option>
                  <option>Dropdown</option>
                  <option>Text Area</option>
                  <option>Date</option>
                  <option>File</option>
                </select>
              </div>
            </div>

            <div class="mb-8 space-y-3"
              v-if="['Checkbox', 'Radio Button', 'Dropdown'].includes(form.role_fields[index].type)">
              <div class="flex items-center" v-for="(option, optionIndex) in form.role_fields[index].options">
                <Label class="text-sm me-2">{{ optionIndex + 1 }}.</Label>
                <input v-model="form.role_fields[index].options[optionIndex].value"
                  :class="{ 'bg-orange-200': form.role_fields[index].options[optionIndex].id }"
                  class="border-0 flex-1 focus:ring-0 h-6 focus:border-0 focus:border-b-2 focus:border-orange-500 p-1 border-b border-gray-400">
                <button type="button" class="ms-5" v-if="form.role_fields[index].options.length > 1"
                  @click="form.role_fields[index].options.splice(optionIndex, 1)">
                  <Icon icon="fa-solid fa-xmark" class="text-gray-500"></Icon>
                </button>
              </div>
              <div class="flex items-center">
                <Label class="text-sm me-2 text-orange-500">{{ form.role_fields[index].options.length + 1 }}.</Label>
                <button class="text-sm text-orange-400 font-semibold underline" type="button"
                  @click="form.role_fields[index].options.push({ id: null, value: '' })">Add option</button>
              </div>
            </div>

            <div class="text-sm flex gap-x-5">
              <div class="flex items-center gap-x-2">
                <input :disabled="form.role_fields[index].alertable" type="checkbox" class="checkbox"
                  v-model="form.role_fields[index].required">
                <label :class="{ 'opacity-30': form.role_fields[index].alertable }">Required</label>
              </div>
              <div class="flex items-center gap-x-2">
                <input type="checkbox" class="checkbox" v-model="form.role_fields[index].issuable">
                <label>Issuable</label>
              </div>
              <div class="flex items-center gap-x-2">
                <input type="checkbox" class="checkbox" v-model="form.role_fields[index].alertable">
                <label>Alertable</label>
              </div>
              <div class="flex items-center gap-x-2">
                <input type="checkbox" class="checkbox" v-model="form.role_fields[index].foreigner_field">
                <label>Field for Foreigner</label>
              </div>
            </div>


            <div class="mt-5">
              <label class="text-sm" :class="{ 'opacity-50': !form.role_fields[index].issuable }">Who can issue this
                field?
                Define Issuers (Only applies if the field is issuable).</label>
              <multiselect v-model="form.role_fields[index].issuers" :disabled="!form.role_fields[index].issuable"
                :multiple="true" :options="users" label="name" track-by="id"
                :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
              </multiselect>
            </div>

            <div class="mt-5">
              <label class="text-sm" :class="{ 'opacity-50': !form.role_fields[index].alertable }">Who should be
                alerted when the field is empty?
                Define Alert Subjects (Only applies if the field is alertable).</label>
              <multiselect v-model="form.role_fields[index].alert_subjects"
                :disabled="!form.role_fields[index].alertable" :multiple="true" :options="users" label="name"
                track-by="id" :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
              </multiselect>

            </div>
            <div class="mt-5">
              <label class="text-sm" :class="{ 'opacity-50': !form.role_fields[index].alertable }">Define the interval
                between each alerts? (Only applies if the field is alertable)</label>
              <select :disabled="!form.role_fields[index].alertable" v-model="form.role_fields[index].alert_period"
                :id="`alertPeriod${index}`" class="dropdown w-full">
                <option>Twice a Day</option>
                <option>Daily</option>
                <option>Weekly</option>
                <option>Monthly</option>
              </select>
            </div>

            <!-- Dropdown menu -->
            <div :id="`dropdown-table${index}`"
              class="z-10 hidden bg-white divide-y divide-gray-100 shadow-md border border-gray-300 w-44 dark:bg-gray-700">
              <ul class="py-2 text-sm text-gray-700 dark:text-gray-200"
                :aria-labelledby="`dropdownDefaultButton${index}`">
                <li>
                  <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
                    type="button" @click="() => {
                      hideDropdown(index);
                      addField(index);
                    }">Add new field below</button>
                </li>
                <li>
                  <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                    type="button" :disabled="index === 0" @click="() => {
                      hideDropdown(index);
                      moveUp(index);
                    }">Move Up</button>
                </li>
                <li>
                  <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                    type="button" :disabled="index === form.role_fields.length - 1" @click="() => {
                      hideDropdown(index);
                      moveDown(index);
                    }">Move Down</button>
                </li>
                <li>
                  <button @click="() => {
                    hideDropdown(index);
                    form.role_fields.splice(index, 1);
                  }" type="button"
                    class="w-full text-start block px-4 py-2 hover:bg-red-100 disabled:opacity-50 disabled:hover:bg-white dark:hover:bg-gray-600 dark:hover:text-white text-red-500">Delete
                    Field
                  </button>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/employee/role" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      
      </div>
    </form>
  </div>
</template>

<script setup>
import { useForm, Link } from '@inertiajs/vue3';
import { watch, onMounted } from 'vue';
import { initDropdowns, Dropdown } from 'flowbite';

const props = defineProps({
  users: Array,
  leaveTypes: Array,
  role: Object,
});

const form = useForm({
  name: props.role.name,
  description: props.role.description,
  create_role: props.role.create_role,
  read_role: props.role.read_role,
  update_role: props.role.update_role,
  delete_role: props.role.delete_role,
  create_user: props.role.create_user,
  read_user: props.role.read_user,
  update_user: props.role.update_user,
  delete_user: props.role.delete_user,
  create_leave_type: props.role.create_leave_type,
  read_leave_type: props.role.read_leave_type,
  update_leave_type: props.role.update_leave_type,
  delete_leave_type: props.role.delete_leave_type,
  create_department: props.role.create_department,
  read_department: props.role.read_department,
  update_department: props.role.update_department,
  delete_department: props.role.delete_department,
  create_form_template: props.role.create_form_template,
  read_form_template: props.role.read_form_template,
  update_form_template: props.role.update_form_template,
  delete_form_template: props.role.delete_form_template,
  roster_eligibility: props.role.roster_eligibility,
  view_overall_roster: props.role.view_overall_roster,
  manage_overall_roster: props.role.manage_overall_roster,
  manage_department_shift: props.role.manage_department_shift,
  admin_dashboard_eligibility: props.role.admin_dashboard_eligibility,
  performance_eligibility: props.role.performance_eligibility,
  view_attendance: props.role.view_attendance,
  observer_eligibility: props.role.observer_eligibility,
  eligible_leaves: props.role.leave_types,
  role_fields: props.role.fields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index).map((roleField) => ({
    'name': roleField.field.name,
    'type': roleField.field.type,
    'options': roleField.field.options.length ? roleField.field.options.sort((optionA, optionB) => optionA.index - optionB.index) : [{ id: null, value: "" }],
    'required': roleField.field.required,
    'issuable': roleField.issuable,
    'alertable': roleField.alertable,
    'alert_period': roleField.alert_period,
    'foreigner_field': roleField.foreigner_field,
    'issuers': roleField.issuers,
    'alert_subjects': roleField.alert_subjects,
    'id': roleField.id
  }))
});

function addField(index) {
  form.role_fields.splice(index + 1, 0, {
    name: '',
    type: 'Text',
    options: [{ id: null, value: "" }],
    required: false,
    issuable: false,
    alertable: false,
    alert_period: 'Day',
    foreigner_field: false,
    issuers: [],
    alert_subjects: [],
    id: null
  })
}

function hideDropdown(index) {
  const target = document.getElementById(`dropdown-table${index}`);
  const trigger = document.getElementById(`dropdownDefaultButton${index}`);

  const dropdown = new Dropdown(target, trigger);
  dropdown.hide();
}

function moveUp(index) {
  var temp = form.role_fields[index];
  form.role_fields[index] = form.role_fields[index - 1];
  form.role_fields[index - 1] = temp;
}

function moveDown(index) {
  var temp = form.role_fields[index];
  form.role_fields[index] = form.role_fields[index + 1];
  form.role_fields[index + 1] = temp;
}

onMounted(() => {
  initDropdowns();
});

//initializing dropdowns on new fields
watch(form.role_fields, (value) => {
  //needs rework but for now it suffices
  setTimeout(initDropdowns, 100);
})
</script>